var byteArray2hexStr = require("./bytes").byteArray2hexStr;
var base64EncodeToString = require("../lib/code").base64EncodeToString;

var _require = require("./crypto"),
    getBase58CheckAddress = _require.getBase58CheckAddress,
    genPriKey = _require.genPriKey,
    getAddressFromPriKey = _require.getAddressFromPriKey;

/**
 * Generate a new account
 */


function generateAccount() {
  var priKeyBytes = genPriKey();
  var addressBytes = getAddressFromPriKey(priKeyBytes);
  var address = getBase58CheckAddress(addressBytes);
  var password = base64EncodeToString(priKeyBytes);
  var privateKey = byteArray2hexStr(priKeyBytes);

  return {
    privateKey: privateKey,
    address: address,
    password: password
  };
}

module.exports = {
  generateAccount: generateAccount
};